"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  SelectFetch: () => SelectFetch,
  useMapToAsyncPaginate: () => useMapToAsyncPaginate,
  useSelectFetch: () => useSelectFetch,
  useSelectFetchBase: () => useSelectFetchBase,
  withSelectFetch: () => withSelectFetch
});
module.exports = __toCommonJS(src_exports);
var import_react_select = __toESM(require("react-select"));

// src/withSelectFetch.tsx
var import_react_select_async_paginate3 = require("react-select-async-paginate");

// src/useSelectFetch.ts
var import_react_select_async_paginate2 = require("react-select-async-paginate");

// src/useMapToAsyncPaginate.ts
var import_react = require("react");
var import_react_select_async_paginate = require("react-select-async-paginate");

// src/stringifyParams.ts
var import_qs = __toESM(require("qs"));
var stringifyParams = (params) => import_qs.default.stringify(params, {
  arrayFormat: "repeat"
});

// src/get.ts
var get = async (url, params) => {
  const paramsStr = stringifyParams(params);
  const response = await fetch(`${url}?${paramsStr}`, {
    credentials: "same-origin"
  });
  if (response.status >= 400) {
    throw new Error("Failed to fetch");
  }
  const responseJSON = await response.json();
  return responseJSON;
};

// src/useMapToAsyncPaginate.ts
var errorText = '[react-select-fetch] response should be an object with "options" prop, which contains array of options. Also you can use `mapResponse` param';
var defaultResponseMapper = (response) => {
  if ((0, import_react_select_async_paginate.checkIsResponse)(response)) {
    return response;
  }
  throw new Error(errorText);
};
var useMapToAsyncPaginate = (selectFetchParams) => {
  const {
    url,
    queryParams = {},
    searchParamName = "search",
    pageParamName = "page",
    offsetParamName = "offset",
    mapResponse = defaultResponseMapper,
    get: get2 = get,
    initialPage = 1,
    defaultInitialPage = 2
  } = selectFetchParams;
  const additional = (0, import_react.useMemo)(
    () => ({
      page: initialPage
    }),
    [initialPage]
  );
  const defaultAdditional = (0, import_react.useMemo)(
    () => ({
      page: defaultInitialPage
    }),
    [defaultInitialPage]
  );
  const loadOptions = (0, import_react.useCallback)(
    async (search, prevOptions, currentAdditional) => {
      if (currentAdditional === void 0) {
        throw new Error();
      }
      const { page } = currentAdditional;
      const params = {
        ...queryParams
      };
      if (searchParamName) {
        params[searchParamName] = search;
      }
      if (pageParamName) {
        params[pageParamName] = page;
      }
      if (offsetParamName) {
        params[offsetParamName] = prevOptions.length;
      }
      const result = await get2(url, params);
      const response = mapResponse(result, {
        search,
        prevPage: page,
        prevOptions
      });
      return {
        ...response,
        additional: {
          page: page + 1
        }
      };
    },
    [
      url,
      queryParams,
      searchParamName,
      pageParamName,
      offsetParamName,
      mapResponse,
      get2
    ]
  );
  return {
    loadOptions,
    additional,
    defaultAdditional
  };
};

// src/useSelectFetch.ts
var useSelectFetch = (params, deps = []) => {
  const mappedParams = useMapToAsyncPaginate(params);
  const result = (0, import_react_select_async_paginate2.useAsyncPaginate)(
    {
      ...params,
      ...mappedParams
    },
    deps
  );
  return result;
};

// src/withSelectFetch.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var defaultCacheUniqs = [];
var defaultComponents = {};
function withSelectFetch(SelectComponent) {
  function WithSelectFetch(props) {
    const {
      components = defaultComponents,
      selectRef = void 0,
      cacheUniqs = defaultCacheUniqs,
      ...rest
    } = props;
    const asyncPaginateProps = useSelectFetch(rest, cacheUniqs);
    const processedComponents = (0, import_react_select_async_paginate3.useComponents)(
      components
    );
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      SelectComponent,
      {
        ...props,
        ...asyncPaginateProps,
        components: processedComponents,
        ref: selectRef
      }
    );
  }
  return WithSelectFetch;
}

// src/useSelectFetchBase.ts
var import_react_select_async_paginate4 = require("react-select-async-paginate");
var useSelectFetchBase = (params, deps = []) => {
  const mappedParams = useMapToAsyncPaginate(params);
  const result = (0, import_react_select_async_paginate4.useAsyncPaginateBase)(
    {
      ...params,
      ...mappedParams
    },
    deps
  );
  return result;
};

// src/index.ts
var SelectFetch = withSelectFetch(import_react_select.default);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SelectFetch,
  useMapToAsyncPaginate,
  useSelectFetch,
  useSelectFetchBase,
  withSelectFetch
});
//# sourceMappingURL=index.js.map